"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const isAction = (action) => (x) => x.key === 'action' && x.value === action;
const isModule = (module) => (x) => x.type === module.toLowerCase();
const isHash = (x) => x.key === 'hash';
exports.findHash = (txResult, resourceType) => {
    return txResult.logs
        .map(x => x.events.find(isModule(resourceType)).attributes)
        .filter(x => x.find(isAction('created')) && x.find(isHash))
        .map(x => x.find(isHash))
        .filter(x => !!x)
        .map(x => x.value);
};
